/*
 * Copyright (c) 2009 OrangeSignal.com All rights reserved.
 *
 * これは Apache ライセンス Version 2.0 (以下、このライセンスと記述) に
 * 従っています。このライセンスに準拠する場合以外、このファイルを使用
 * してはなりません。このライセンスのコピーは以下から入手できます。
 *
 * http://www.apache.org/licenses/LICENSE-2.0.txt
 *
 * 適用可能な法律がある、あるいは文書によって明記されている場合を除き、
 * このライセンスの下で配布されているソフトウェアは、明示的であるか暗黙の
 * うちであるかを問わず、「保証やあらゆる種類の条件を含んでおらず」、
 * 「あるがまま」の状態で提供されるものとします。
 * このライセンスが適用される特定の許諾と制限については、このライセンス
 * を参照してください。
 */

package jp.sf.orangesignal.csv.handlers;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import jp.sf.orangesignal.csv.CsvListHandler;
import jp.sf.orangesignal.csv.CsvReader;
import jp.sf.orangesignal.csv.CsvWriter;

/**
 * 文字列配列のリストで区切り文字形式データアクセスを行うハンドラを提供します。
 *
 * @author 杉澤 浩二
 */
public class StringArrayListHandler implements CsvListHandler<String[]> {

	/**
	 * 取得データの開始位置を保持します。
	 */
	private int offset;

	/**
	 * 取得データの限度数を保持します。
	 */
	private int limit;

	/**
	 * デフォルトコンストラクタです。
	 */
	public StringArrayListHandler() {}

	/**
	 * 取得データの開始位置を設定します。
	 * 
	 * @param offset 取得データの開始位置
	 * @return このオブジェクトへの参照
	 * @since 1.2.2
	 */
	public StringArrayListHandler offset(final int offset) {
		this.offset = offset;
		return this;
	}

	/**
	 * 取得データの限度数を設定します。
	 * 
	 * @param limit 取得データの限度数
	 * @return このオブジェクトへの参照
	 * @since 1.2.2
	 */
	public StringArrayListHandler limit(final int limit) {
		this.limit = limit;
		return this;
	}

	@Override
	public List<String[]> load(final CsvReader reader) throws IOException {
		final List<String[]> results = new ArrayList<String[]>();
		int offset = 0;
		List<String> values;
		while ((values = reader.readValues()) != null && (limit <= 0 || results.size() < limit)) {
			if (offset < this.offset) {
				offset++;
				continue;
			}
			results.add(values.toArray(new String[0]));
		}
		return results;
	}

	@Override
	public void save(final List<String[]> list, final CsvWriter writer) throws IOException {
		for (final String[] values : list) {
			writer.writeValues(Arrays.asList(values));
		}
	}

}
